jueves, agosto 16, 2007

Compiz Fusion en Debian Lenny con Nvidia o Intel

Actualización 06/10/2007: Chantanito nos ha acercado un excelente dato al apuntarnos con su comentario que los repositorios shame han sido separados por release. Yo no me había percatado de ello pues ya tengo compiz instalado ;-) En el repository of shame tienen toda la data de cual es la línea que deben agregar al sources.list. Para los impacientes que tenemos Debian Lenny 32 bits, es la siguiente:

deb http://download.tuxfamily.org/shames/debian-lenny/desktopfx/unstable/ ./
Mil gracias!!

Como ustedes saben, por junio de este año los proyectos de escritorios 3d Beryl y Compiz se unieron para dar nacimiento a Compiz Fusion, del cual pueden ver algunos videos, como es usual, en youtube.

Esta semana han dado a conocer la primer release de desarrollo, Compiz Fusion 0.5.2, que he probado en dos equipos y la verdad anda sin problemas incluso con una performance un poco mejor (al menos a mi juicio) que los proyectos originales. Algunas de las novedades que se incorporaron, además de los plugins de Compiz y Beryl originales, son:
  • Efectos de reflexión en el cubo
  • Un plugin de exposición de escritorios
  • Un nuevo selector de aplicaciones
  • Un completo gestor de configuración
Para los impacientes, aquí está la receta para tenerlo andando en Debian Lenny. La publico ahora (un poco tarde, por cierto) pues el repositorio de paquetes está más estable que hace unos días.

1. Instalación de los drivers de video

Para aquellos que poseen tarjetas de video nVidia, deben tener instalado y configurado el driver propietario, de lo cual ya hemos hablado en un post anterior. Con algunas modificaciones, las instrucciones son las mismas.

Por las dudas, si tenemos una placa de video nVidia, en el archivo /etc/X11/xorg.conf deberíamos tener:
...
Section "Device"
Identifier "Tarjeta de vídeo genérica"
Driver "nvidia"
Option "AllowGLXWithComposite" "true"
Option "RenderAccel" "true"
EndSection
...
Section "Screen"
...
Option "AddARGBGLXVisuals" "True"
...
EndSection
...
Section "Extensions"
Option "Composite" "Enable"
EndSection
...
Para el caso de una placa de video Intel 915/945/9xx:
...
Section "Device"
...
Option "XAANoOffscreenPixmaps" "True"
...
EndSection
...
Section "Extensions"
Option "Composite" "Enable"
EndSection
...
2. Eliminar los paquetes antiguos de Beryl y Compiz

He tenido algunas dificultades al intentar actualizar los paquetes desde versiones antiguas, por lo que recomiendo remover y purgar todos los paquetes relacionados con Compiz y Beryl que estén instalados en el equipo.

# aptitude purge beryl... compiz... heliodor... emerald... etc, etc...

3. Agregar el repositorio shame

Esta buen alma caritativa se ha encargado de empaquetar Compiz Fusion para Debian, así que aprovecho para agradecer su laburo.

Agregar, entonces, las líneas siguientes a /etc/apt/sources.list

# Compiz Fusion development (shame)
deb http://download.tuxfamily.org/shames/debian-sid/desktopfx/unstable/ ./

Update 06/09/2007

Agrego dos repos más por si tienen problemas con el anterior. El siguiente es también de shame, pero contiene una versión más antigua y un poco más estable de compiz:

deb http://download.tuxfamily.org/shames/debian-sid/desktopfx/snapshot/ ./

Este último lo encontré de casualidad y proviene del O.S. Revolution Unnoficial Debian Repository:

deb http://download.tuxfamily.org/osrdebian unstable compiz-fusion-git

4. Agregar las llaves del repositorio

# wget http://download.tuxfamily.org/shames/A42A6CF5.gpg -O- | apt-key add -

5. Instalar los paquetes de Compiz Fusion

Dependiendo del entorno escritorio en el cual deseamos ver los efectos gráficos, es conveniente instalar...

# aptitude install compiz-fusion-kde (para KDE)
# aptitude install compiz-fusion-gnome (para Gnome)
# aptitude install compiz-gnome emerald emerald-themes (para XFCE)
# aptitude install compiz-fusion-all (todos los paquetes para cualquier entorno)

6. Iniciar Compiz Fusion

Como usuario normal, una vez iniciada la sesión en el escritorio de preferencia, ejecutar

$ fusion-icon

o bien

$ fusion-manager

Como he tenido algunos inconvenientes con gtk-window-decorator, les recomiendo iniciar con el decorador de ventanas emerald. Para ello en vez de ejecutar fusion-icon, ejecuten compiz y luego inicien emerald, de la siguiente forma:

$ compiz &
$ emerald &

Eso debería andar; o por lo menos en mi modesta pc con 256 de RAM y 256 de video anda muy lindo.
Bien, por ahora es todo, los dejo para que disfruten de los atractivos efectos y saquen sus propias conclusiones.

14 comentarios:

Iñaki Silanes dijo...

Muy interesante este post, sobre todo porque yo mismo estoy haciendo andar también Compiz Fusion sobre Debian Lenny. Mi problema es que uso una tarjeta ATI (además de un kernel de 64bits, aunque creo que tú también tienes un Core 2 Duo), así que uso Xgl, en vez de AIXGL, y ello me ha dado algún quebradero de cabeza (aunque ahora lo tengo funcionando).

Quería comentarte simplemente que los comandos que das para iniciar compiz y emerald se pueden hacer más "limpios" en una línea:

compiz --replace -c emerald

Enhorabuena por tu blog, y por entradas como esta.

Un saludo.

Mauro Meloni dijo...

Gracias por el aporte, Iñaki. Me tomo el atrevimiento de añadir un enlace a tu blog donde explicas con muy buen detalle la configuración de Compiz Fusion con XGL en tarjetas de video ATI.

Pues bien, aquí dejo el enlace para el resto de nosotros.

Felicitaciones por el blog y cordiales saludos.

Anónimo dijo...

Hola Mauro, me llamo Ezequiel, soy de mar del plata y hace varios dias que estoy renegando con esto del compiz, aun no logre hacerlo funcionar.
Mi laptop es una compaq V3218LA, AMD64 Turion de 2 Ghz, tiene Nvidia 6150 comparte hasta 128 de RAM, en total tengo 1.5 Gb de Ram. Estoy usando Debian Etch 4.0. Lo instale hace poco asi que relativamente esta "virgen" la instalacion, no le hice ninguna configuracion "rara" ademas soy nuevo en el mundo linux. Lo unico que le cargue es el ndiswrapper para wifi y los drivers ultimos de Nvidia, ya me sale el logo de nvidia antes del inicio del gnome.
La cuestion es que sigo las instrucciones de los instructivos y no funciona, cuando le pongo compiz --replace se congela el escritorio, solo se mueve el mouse. Tengo q ir a consola y reiniciar el gdm.
Si no es mucha molestia para vos y puedes darme una mano para ver que otra cosa puedo agregar te lo agredecere un monton.
Si utilizas MSN te dejo mi mail: eze_mdp@hotmail.com.
Desde ya muchas gracias
Saludos
Ezequiel

Mauro Meloni dijo...

Ezequiel, por lo general recomiendo primero verificar que la aceleración ande correctamente invocando

glxgears

Luego conviene probar algún juego 3D para verificar su performance.

Finalmente, te recomiendo que ejecutes

compiz -v --replace -c emerald &

en una ventana de terminal, para iniciar compiz. Esto hace tres cosas:

-v activa el modo verbose, con lo cual al cargar compiz, se despliegan algunos mensajes que pueden servir para encontrar el inconveniente.

--replace hace que compiz reemplace el gestor de ventana actual.

-c emerald como explica Iñaki en el comentario anterior, hace que se cargue por defecto el decorador emerald. Pues con el otro he tenido problemas.

Probalo y me contás por MSN que tal salió.

Cordiales saludos.

Ale dijo...

Enhorabuena por el blog Mauro, me ha sido de gran ayuda.

Ale dijo...

Enhorabuena por el blog Mauro, me ha sido de gran ayuda.

MeDoRiO dijo...

oye mauro si tengo una hp pavillion con acelerador de gráficos Intel 950 y cuento con ubuntu 7.04 que debo hacer para instalar compiz fusion, ojala puedas ayudarme...

saludos.

odmunde dijo...

Mira yo tengo este problema con una intel 915GM y no me corren los efectos del compiz fusion en ubuntu ultimate 1.4 ya le di esto comandos y me aparece lo siguiente

odmunde@odmunde-laptop:~$ glxgears
(si aparecen llos engranes girando)

odmunde@odmunde-laptop:~$ glxinfo | grep rend
direct rendering: Yes
OpenGL renderer string: Mesa DRI Intel(R) 915GM 20061017 x86/MMX/SSE2

odmunde@odmunde-laptop:~$ grep EE /var/log/Xorg.0.log
(WW) warning, (EE) error, (NI) not implemented, (??) unknown.
(II) Loading extension MIT-SCREEN-SAVER
(EE) xf86OpenSerial: Cannot open device /dev/input/wacom
(EE) xf86OpenSerial: Cannot open device /dev/input/wacom
(EE) xf86OpenSerial: Cannot open device /dev/input/wacom

espero puedan ayudarme a hacer funcionar lao efectos

Gracias Odmunde

Chantanito dijo...

Hola, muy interesante de verdad tu artículo. Justamente en éste momento estaba intentando llevarlo a cabo pero al parecer hay problemas con las dependencias. Empezó a mostrarme los siguientes errores: http://paste.debian.net/38983
Pero luego, indagando un poco, me enteré que en los repositorios de Shame hicieron un split de Lenny y Sid, así que simplemente modifiqué la línea del sources.list y voilâ. Puedes hacer esa modificaciones al artículo para que no pierda vigencia. Saludos.

DanFilth dijo...

Hola disculpa cuento con una laptop HP con tarjeta de video Intel(R) 915GM, hize todo le procedimiento sin embargo no logro hacer que funcionen las animaciones, sige todo igual, uso debian lenny saludos espero puedas yudarme

Odair Trujillo dijo...

Hola, no tengo el comando fusion-icon, que crees que pase?

Mauro Meloni dijo...

La utilidad fusion-icon es recomendable, pero no necesaria para utilizar compiz.

Debería bastar con ejecutar

compiz --replace &

en una terminal de comandos.

De todas formas esta guía ya está un poco obsoleta, pues, por ejemplo, los paquetes de compiz-fusion ya están disponibles en el repositorio de Debian Lenny.
Espero hacerme un tiempo para publicar una guía nueva.

walltert dijo...

Gracias pana esta demasiado bueno y me sirvio saludosssssssss...

Juanpi dijo...

hola, muchas gracias por el post, solo que a mi me presenta el siguiente problema con los paquetes al final mira:

root ~ # apt-get install compiz-fusion-all
Leyendo lista de paquetes... Hecho
Creando árbol de dependencias
Leyendo la información de estado... Hecho
Se instalarán los siguientes paquetes extras:
compiz compiz-core compiz-dev compiz-fusion-bcop compiz-fusion-extras compiz-fusion-plugins-extra
compiz-fusion-plugins-unstable compiz-fusion-plugins-unsupported compiz-gnome compiz-kde compiz-ma
compizconfig-backend-kconfig compizconfig-settings-manager emerald emerald-themes fusion-icon libc
libdecoration0-dev libemeraldengine-dev libemeraldengine0 libgnome-window-settings1 libstartup-not
Paquetes sugeridos:
python-sexy
Se instalarán los siguientes paquetes NUEVOS:
compiz compiz-core compiz-dev compiz-fusion-all compiz-fusion-bcop compiz-fusion-extras compiz-fus
compiz-fusion-plugins-unstable compiz-fusion-plugins-unsupported compiz-gnome compiz-kde compiz-ma
compizconfig-backend-kconfig compizconfig-settings-manager emerald emerald-themes fusion-icon libc
libdecoration0-dev libemeraldengine-dev libemeraldengine0 libgnome-window-settings1 libstartup-not
0 actualizados, 30 se instalarán, 0 para eliminar y 4 no actualizados.
Se necesita descargar 11,4MB/12,5MB de archivos.
Se utilizarán 29,5MB de espacio de disco adicional después de esta operación.
¿Desea continuar [S/n]? S
Des:1 http://download.tuxfamily.org ./ compiz-core 1:0.7.9+git20080918.shame-0 [832kB]
Err http://download.tuxfamily.org ./ compiz-core 1:0.7.9+git20080918.shame-0
403 Forbidden
Des:2 http://download.tuxfamily.org ./ compiz-fusion-plugins-main 0.7.9+git20080923.shame-0 [742kB]
Des:3 http://download.tuxfamily.org ./ compiz-fusion-plugins-unsupported 0.7.9+git20080923.shame-0 [
110kB]
Des:4 http://download.tuxfamily.org ./ compiz-gnome 1:0.7.9+git20080918.shame-0 [322kB]
Des:5 http://download.tuxfamily.org ./ libcompizconfig-dev 0.7.9+git20080923.shame-0 [50,3kB]
Des:6 http://download.tuxfamily.org ./ compizconfig-settings-manager 0.7.9+git20080923.shame-0 [685k
B]
Des:7 http://download.tuxfamily.org ./ compiz-fusion-plugins-extra 0.7.9+git20080923.shame-0 [2096kB
]
Des:8 http://download.tuxfamily.org ./ emerald 0.7.9+git20080923.shame-0 [261kB]
Des:9 http://download.tuxfamily.org ./ libemeraldengine-dev 0.7.9+git20080923.shame-0 [71,3kB]
Des:10 http://download.tuxfamily.org ./ emerald-themes 0.7.9+git20071021.shame-1 [1472kB]
Des:11 http://download.tuxfamily.org ./ compiz-fusion-extras 0.7.9+git20080923.shame-0 [4183kB]
Des:12 http://download.tuxfamily.org ./ compiz-fusion-plugins-unstable 0.7.9+git20080923.shame-1 [57
2kB]
Des:13 http://download.tuxfamily.org ./ simple-ccsm 0.7.9+git20080923.shame-0 [48,3kB]
Descargados 9344kB en 8min37s (18,1kB/s)
Imposible obtener http://download.tuxfamily.org/shames/debian-lenny/desktopfx/unstable/./compiz-core
_0.7.9+git20080918.shame-0_i386.deb 403 Forbidden
E: No se pudieron obtener algunos archivos, ¿quizás deba ejecutar
apt-get update o deba intentarlo de nuevo con --fix-missing?


que puedo hacer??? Gracias de antemano

saludos